#!/bin/bash
#
# 1) converts ambiguous arff files to complete arff files
# 2) converts these complete arff files to swi prolog files
# 3) converts these prolog files to tilde files

FileAmbiguous=$1   			# prefixe du fichier (sans .arff)
FileBkg=$2				    # prefixe du fichier (sans .bkg)
FileTest=$3                 # prefixe du fichier (sans .pl)
Concept=$4                  # name (and arguments) of the concept one learns


FileComplete=c${FileAmbiguous}
FileNeg="${FileComplete}_neg"
fileS=${FileNeg}.s
fileBg=${FileNeg}.bg

cat << MARQUE1.txt | swipl  
consult('${LEAR_DIR}/AQa_mt13').
writeln('ambiguous to complete').
ambiguous_to_complete('${FileAmbiguous}').
writeln('create double representation').
create_arff_neg2('${FileComplete}').			
writeln('translation to prolog format').
arff_to_prolog('${FileNeg}', '${FileBkg}', train).
writeln('ok').
halt.
MARQUE1.txt


cat << MARQUE2 | swipl  
consult('${LEAR_DIR}/leaToTilde').
writeln('translation to tilde format').
convert('${FileNeg}', '${FileTest}', '${Concept}').  
halt.
MARQUE2


												
			# copie des fichiers dans new dossier

directory=${FileNeg}
echo $directory
mkdir $directory									
cp 'Mtrain630.s' $directory/$fileS
cp 'Mtrain630.bg' $directory/$fileBg
mv ${FileNeg}.kb $directory

exit 0
