#!/usr/bin/python3.2

# (home + travail + magi)

# ==============================================================================
#         CLEAN SOME FILES CREATED BY LEAR_NK_CROSS_VALIDATION_ONE_PROBA.PY	
#	
# script     = sys.argv[0]       # nom du script
# fileEx     = sys.argv[1]       # file containing intentionsal complete examples (.int)
# fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
# nbCross    = int(sys.argv[3])  # number of cross validations 
# nbFold     = int(sys.argv[4])  # number of folds of the cross validation 
# probaMin   = sys.argv[5]       # level of ambiguity min (percentage)
# probaMax   = sys.argv[6]	   # level of ambiguity max (percentage)

# =================================== IMPORTS ==================================

import sys
import os
import shutil

# =================================== FONCTIONS ================================
	
					# efface le fichier fileName
def removeFile(fileName):
		if os.path.exists(fileName) :
			print("efface : " + fileName)
			os.remove(fileName)
	
def removeDir(dirName) :
	if os.path.exists(dirName) :
		print("efface : " + dirName)
		shutil.rmtree(dirName)

	
					# clear some files of a nbFold cross validation
def crossValidationClear(processName, fileEx, fileExcel, fileExcelProba,
       			     	 cross, nbFold, proba) :
 					
					# we are in the proba directory
	suffixCross = "_n" + str(cross)
	fileExcel = fileExcel + suffixCross

	currentDirectory = os.getcwd()

	baseName = os.path.basename(currentDirectory)
	baseCrossDirectory = baseName + suffixCross
	crossDirectory = os.path.join(currentDirectory, baseCrossDirectory)
	os.chdir(crossDirectory)	
	
					# we are in the cross directory
	removeFile(processName + ".out")
	removeFile(processName + ".err")

	removeFile(fileExcel + ".csv")	

	for fold in range(1, nbFold+1) :
			
		print("fold : ", fold),
		foldBase = baseCrossDirectory + "_fold" + str(fold)
							
					# go to the directory of the current fold
		foldDirectory = os.path.join(crossDirectory, foldBase) 
		os.chdir(foldDirectory)
		
					# build the name of the lear files
		train          = foldBase + "_train_ambiguous"     
		trainRemaining = train    + "_remaining"
		test           = foldBase + "_test"
		testRemaining  = test     + "_remaining" 	

		removeFile(train + ".pl")
		removeFile(train + ".res")
#		removeFile(test + ".pl")
		removeFile(trainRemaining + ".int")
		removeFile(testRemaining + ".int")
		
					# return to the cross directory
		os.chdir("..")	 
	
					# return to the proba directory
	os.chdir("..")	

# ===================================== MAIN ===================================

script     = sys.argv[0]       # nom du script
fileEx     = sys.argv[1]       # file containing intentionsal complete examples (.int)
fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
nbCross    = int(sys.argv[3])  # number of cross validations 
nbFold     = int(sys.argv[4])  # number of folds of the cross validation 
probaMin   = int(sys.argv[5])  # level of ambiguity min (percentage)
probaMax   = int(sys.argv[6])  # level of ambiguity max (percentage)

print("begin of the script ", script)

for proba in range(probaMin, probaMax+1, 10):

	print()
	print("======================================")
	print()
	print("proba = " + str(proba))
	print()
	print()

	suffixProba 	= "_p" 		+ str(proba)
	fileExcelProba 	= fileExcel + suffixProba + ".csv"
	fileExcel1		= fileExcel + suffixProba
	directoryProba 	= fileEx    + suffixProba
	
							    # we go in the proba directory
	os.chdir(directoryProba)	
	removeFile(fileExcelProba)
			
								# lance les cross validations
	for cross in range(0, nbCross) :
		
		print()		
		print("cross = " , cross)

		processName = "lear" + suffixProba + "_n" + str(cross)
		crossValidationClear(processName, fileEx, fileExcel1, 
					      fileExcelProba, cross, nbFold, proba)	
	
		removeFile("lear" + suffixProba + ".err")
		removeFile("lear" + suffixProba + ".out")		
		
	removeFile(fileExcel1 + ".csv")

	os.chdir("..")				# return in the initial directory

			
print("end of the script ", script)

# ====================================== END ===================================
