#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#                           CREATE N CONCURRENT K CLOSE WORD COMPLETIONS
#                           FOR EACH LEVEL OF AMBIGUITY		   
#
#	script     = sys.argv[0]       	# nom du script
#	fileEx     = sys.argv[1]       	# file containing train intentionsal complete examples (.int)
#	fileBkg    = sys.argv[2]       	# file containing background knowledge
#	nbCross    = int(sys.argv[3])  	# cross validation identifier
#	nbFold     = int(sys.argv[4])  	# number of folds of the cross validation
#	probaMin   = sys.argv[5]           # min level of ambiguity
#	probaMax   = sys.argv[6]           # max level of ambiguity

# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     = sys.argv[0]       # script name
	fileEx     = sys.argv[1]       # file containing train intentionsal complete examples (.int)
	fileBkg    = sys.argv[2]       # file containing background knowledge
	nbCross    = sys.argv[3]       # cross validation identifier
	nbFold     = sys.argv[4]       # number of folds of the cross validation
	probaMin   = int(sys.argv[5])  # min level of ambiguity
	probaMax   = int(sys.argv[6])  # max level of ambiguity

	print("begin of the script ", script)

	for ambiguity in range(probaMin, probaMax+1, 10):

		print("ambiguity = ", ambiguity)

						# call the completion script
		program = "magi_close_world_completion_one_proba.py"
		args = [program, fileEx, fileBkg, nbCross, nbFold, str(ambiguity)]
		subprocess.call(args)

	print("end of the script ", script)

# ====================================== END ===================================
