#!/usr/bin/python3.2
# (home + travail)

#!/usr/local/python32/bin/python3.2
# (magi)

# ==============================================================================
#                           CREATE N CONCURRENT K CROSS-VALIDATIONS	
#                           FOR EACH LEVEL OF AMBIGUITY				   
#
#	script     = sys.argv[0]         # script name
#	fileEx     = sys.argv[1]         # file containing train intentionsal complete examples (.int)
#	fileBkg    = sys.argv[2]         # file containing background knowledge
#	fileExcel  = sys.argv[3]         # prefix of files that will contain results in excel format
#	nbCross    = sys.argv[4]         # cross validation identifier
#	nbFold     = sys.argv[5]         # number of folds of the cross validation
#    factor     = sys.argv[6]         # create factor ambiguous examples from each complete example   
#	nbErrors   = sys.argv[7]       e  # number of accepted errors on negative examples
#	nbTries    = sys.argv[8]         # number of tries to enhance an hypothesis
#                                     # having less than nbErrors
#	compWeight = sys.argv[9]	        # weight of the only compatible examples
#	doubleRep  = sys.argv[10]	   # double representation (double_representation) 
#	probaMin   = int(sys.argv[11])   # min level of ambiguity
#	probaMax   = int(sys.argv[12])  

# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     = sys.argv[0]       	 # script name
	fileEx     = sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
	fileBkg    = sys.argv[2]       	 # file containing background knowledge
	fileExcel  = sys.argv[3]       	 # prefix of files that will contain results in excel format
	nbCross    = sys.argv[4]       	 # cross validation identifier
	nbFold     = sys.argv[5]       	 # number of folds of the cross validation
	factor     = sys.argv[6]         	 # create factor ambiguous examples from each complete example   
	nbErrors   = sys.argv[7]       	 # number of accepted errors on negative examples
	nbTries    = sys.argv[8]       	 # number of tries to enhance an hypothesis
                                     	 # having less than nbErrors
	compWeight = sys.argv[9]	     	 # weight of the only compatible examples
	doubleRep  = sys.argv[10]		 # double representation (double_representation) 
	probaMin   = int(sys.argv[11])   	 # min level of ambiguity
	probaMax   = int(sys.argv[12])   	 # max level of ambiguity


	print("begin of the script ", script)

	for ambiguity in range(probaMin, probaMax+1, 10):

		print("ambiguity = ", ambiguity)

						# call magi_lear_one_proba.py
		program = "magi_lear_one_proba.py"
		args = [program, fileEx, fileBkg, fileExcel, nbCross, nbFold,
                  factor, str(ambiguity), nbErrors, nbTries, 
                  compWeight, doubleRep]
		subprocess.call(args)

	print("end of the script ", script)

# ====================================== END ===================================
