#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#                           CREATE N CONCURRENT K CROSS-VALIDATIONS	
#                           FOR EACH LEVEL OF AMBIGUITY
#					   FOR LEAR, TILDE AND NFOIL				   
#
#	script     	= sys.argv[0]       	 # script name
#	fileEx     	= sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
#	fileBkg    	= sys.argv[2]       	 # file containing background knowledge
#	fileExcelLear  = sys.argv[3]       	 # prefix of files that will contain Lear results
#	nbCross    	= sys.argv[4]       	 # cross validation identifier
#	nbFold     	= sys.argv[5]       	 # number of folds of the cross validation
#	factor     	= sys.argv[6]         	 # create factor ambiguous examples from each complete example   
#	nbErrors   	= sys.argv[7]       	 # number of accepted errors on negative examples
#	nbTries    	= sys.argv[8]       	 # number of tries to enhance an hypothesis
                                     	 	 # having less than nbErrors
#	compWeight 	= sys.argv[9]	     	 # weight of the only compatible examples
#	doubleRep		= sys.argv[10]			 # double when double representation is used
#	probaMin   	= int(sys.argv[11])  	 # min level of ambiguity
#	probaMax   	= int(sys.argv[12]) 	 # max level of ambiguity


# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# =================================== FONCTIONS ================================

def displayMessage(Message) :
	print()
	print("__________________________________________________________________")
	print("                             ", Message)
	print("__________________________________________________________________")
	print()

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     	= sys.argv[0]       	 # script name
	fileEx     	= sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
	fileBkg    	= sys.argv[2]       	 # file containing background knowledge
	fileExcelLear  = sys.argv[3]       	 # prefix of files that will contain Lear results
	nbCross    	= sys.argv[4]       	 # cross validation identifier
	nbFold     	= sys.argv[5]       	 # number of folds of the cross validation
	factor     	= sys.argv[6]         	 # create factor ambiguous examples from each complete example   
	nbErrors   	= sys.argv[7]       	 # number of accepted errors on negative examples
	nbTries    	= sys.argv[8]       	 # number of tries to enhance an hypothesis
                                     	 	 # having less than nbErrors
	compWeight 	= sys.argv[9]	     	 # weight of the only compatible examples
	doubleRep		= sys.argv[10]			 # double when double representation is used
	probaMin   	= int(sys.argv[11])  	 # min level of ambiguity
	probaMax   	= int(sys.argv[12]) 	 # max level of ambiguity

	print("begin of the script ", script)

	for proba in range(probaMin, probaMax+1, 10):

		print()
		print("========= ambiguity = ", proba, "============================")
		print()

						# call magi_lear_tilde_nfoil_one_proba.py
		program = "magi_lear_completion_one_proba.py"
		args = [program, fileEx, fileBkg, 
			   fileExcelLear, nbCross, nbFold, factor, nbErrors, nbTries, 
			   compWeight, doubleRep, str(proba)]
		subprocess.call(args)
			
	print("end of the script ", script)

# ====================================== END ===================================
