#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#                           CREATE N CONCURRENT K CROSS-VALIDATIONS	
#                           FOR EACH LEVEL OF AMBIGUITY
#					   FOR LEAR, TILDE AND NFOIL				   
#
#	script     	= sys.argv[0]       	 # script name
#	fileEx     	= sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
#	fileBkg    	= sys.argv[2]       	 # file containing background knowledge
#	fileExcelLear  = sys.argv[3]       	 # prefix of files that will contain Lear results
#	nbCross    	= sys.argv[4]       	 # cross validation identifier
#	nbFold     	= sys.argv[5]       	 # number of folds of the cross validation
#	factor     	= sys.argv[6]         	 # create factor ambiguous examples from each complete example   
#	nbErrors   	= sys.argv[7]       	 # number of accepted errors on negative examples
#	nbTries    	= sys.argv[8]       	 # number of tries to enhance an hypothesis
                                     	 	 # having less than nbErrors
#	compWeight 	= sys.argv[9]	     	 # weight of the only compatible examples
#	doubleRep		= sys.argv[10]			 # double when double representation is used
#	proba   		= sys.argv[11]   	 	 # level of ambiguity

# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# =================================== FONCTIONS ================================

def displayMessage(Message) :
	print()
	print("__________________________________________________________________")
	print("                             ", Message)
	print("__________________________________________________________________")
	print()

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     	= sys.argv[0]       	 # script name
	fileEx     	= sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
	fileBkg    	= sys.argv[2]       	 # file containing background knowledge
	fileExcelLear  = sys.argv[3]       	 # prefix of files that will contain Lear results
	nbCross    	= sys.argv[4]       	 # cross validation identifier
	nbFold     	= sys.argv[5]       	 # number of folds of the cross validation
	factor     	= sys.argv[6]         	 # create factor ambiguous examples from each complete example   
	nbErrors   	= sys.argv[7]       	 # number of accepted errors on negative examples
	nbTries    	= sys.argv[8]       	 # number of tries to enhance an hypothesis
                                     	 	 # having less than nbErrors
	compWeight 	= sys.argv[9]	     	 # weight of the only compatible examples
	doubleRep		= sys.argv[10]			 # double when double representation is used
	proba   		= sys.argv[11]   	 	 # level of ambiguity

	print("begin of the script ", script)

									 # call LEAR
	displayMessage("LEAR")
	program = "magi_lear_one_proba.py"
	args = [program, fileEx, fileBkg, fileExcelLear, nbCross, nbFold,
            factor, proba, nbErrors, nbTries, compWeight, doubleRep]
	subprocess.call(args)
									# call CLOSE WORLD COMPLETION
	displayMessage("COMPLETION")
	program = "magi_close_world_completion_one_proba.py"
	args = [program, fileEx, fileBkg, nbCross, nbFold, proba]
	subprocess.call(args)
							
	print("end of the script ", script)

# ====================================== END ===================================
