#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#            GET THE NUMBER OR FULES FOUND BY LEAR FOR ONE LEVEL OF AMBIGUITY					   

# ================================ ARGUMENTS ===================================
#	script     = sys.argv[0]       	 # script name
#	fileEx     = sys.argv[1]       	 # file name for the examples 
#	nbCross    = sys.argv[2]       	 # number of cross validations 
#	nbFold     = sys.argv[3]       	 # number of folds of each cross validation
#	ambiguity	 = int(sys.argv[4])   	 # level of ambiguity

# =================================== IMPORTS ==================================

import sys
import os
import multiprocessing as mp
import subprocess

# =============================== VARIABLES GLOBALES ===========================

learDirectory = os.getenv('LEAR_DIR')
LEAR = os.path.join(learDirectory, "topLear3.pl")
lockFileProba = mp.Lock()     	

# =================================== FONCTIONS ================================
	
					# make a nbFold cross validation
def crossValidation(fileProba, fileEx, cross, nbFold, ambiguity) :

					# we are in the proba directory
	processName = mp.current_process().name
	suffixCross = "_n" + str(cross)			
	currentDirectory = os.getcwd()
	baseName = os.path.basename(currentDirectory)
	baseCrossDirectory = baseName + suffixCross

					# go to the current cross validation directory
	crossDirectory = os.path.join(currentDirectory, baseCrossDirectory)
	os.chdir(crossDirectory)	
	fileCross = fileProba + suffixCross

	pOut = open(fileCross + ".stats", "w") 
	print("fileCross = ", fileCross)			     
          	         						     		               	
	for fold in range(1, nbFold+1) :
			
					# go to the current fold directory 
		print("fold : ", fold),
		foldBase = baseCrossDirectory + "_fold" + str(fold)
		foldDirectory = os.path.join(crossDirectory, foldBase) 
		os.chdir(foldDirectory)									
							
		fileDirectory = os.path.basename(foldDirectory)
		
					# name of the file containings the results of Lear
		fileResultsFold = fileDirectory + "_train_ambiguous.res" 

		(nbRules, lengthRules) = getFoldStats(fileResultsFold)
		writeFoldStats(pOut)
	
					# return to the cross directory	
		os.chdir("..")	

	pOut.close()

					# get the average of the results of the nbFold folds
	crossValidationResults = utilities.getCrossValidationResults(fileExcelCross + ".csv")
	
					# return to the proba directory
	os.chdir("..")		
		
					# save results
	lockFileProba.acquire()
	utilities.addCrossStatsResults(fileProba, crossValidationResults)
	lockFileProba.release()


		# get the number of rules and the average lenght of rules
		# learned by Lear in the current fold
def getFoldStats(fileResultsFold) :
					
					# read the file
	f = open(fileResultsFold, "r")
	lines = fResults.readlines()
	f.close()
					# get the rules (the last lines of the file)
	nbLines = len(lines)

	i = 0
	found = false
	while (i < nbLines) and (not found) :
		if lines[i].find("set of rules") == 0


	


		# add the means of accuracyPlus, accuracyMoins, accuracy, accuracyMean
		# of the folds of the current crossValidation
def addCrossStatsResults(fileProba, results) :
	
	(accuracyPlusAVG, accuracyMoinsAVG, accuracyAVG, accuracyMeanAVG) = results
	
	f = open(fileProba, "a")
	f.write(str(accuracyPlusAVG) + ";" + str(accuracyMoinsAVG) + ";" +
		    str(accuracyAVG)     + ";" + str(accuracyMeanAVG)  + "\n")		
	f.close()


# ===================================== MAIN ===================================

if __name__ == '__main__' :


	script     = sys.argv[0]       	 # script name
	fileEx     = sys.argv[1]       	 # file name for the examples 
	nbCross    = sys.argv[2]       	 # number of cross validations 
	nbFold     = sys.argv[3]       	 # number of folds of each cross validation
	ambiguity	 = int(sys.argv[4])   	 # level of ambiguity	

	print("begin of the script ", script)

	suffixProba 	= "_p"   + ambiguity
	fileProba 	= fileEx + suffixProba 
	directoryProba = fileEx    + suffixProba

	os.chdir(directoryProba)	
					
	processes = []

							# creation des process crossValidation
	for cross in range(0, nbCross) :	
		processes.append(
			             mp.Process(
						         target = crossValidation, 
						         name = "lear_stats_rules_p" + ambiguity +
                                              "_n" + str(cross), 
						         args = (
							             fileProba, fileEx, 
									   cross, nbFold, ambiguity,
							            )
                                     )
                          )   						

							# running the cross validations	  
	for p in processes : 
		p.start()      

							# waiting for the cross validations terminate
	for p in processes : 	
	 	p.join()       

	print("end of the script ", script)

# ====================================== END ===================================
