#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#					   draw nbEx examples satisfying a background knowledge
#					   sort them as positive and negative examples of a
#					   given target concept and 
#                           CREATE N CONCURRENT K CROSS-VALIDATIONS	
#                           FOR EACH LEVEL OF AMBIGUITY
#					   FOR LEAR, TILDE AND NFOIL				   

#	script     	= sys.argv[0]       	 # script name
#	fileLanguage	= sys.argv[1]			 # file (int_bkg) containing the background and the concept
#	nbEx			= sys.argv[2]			 # number of random examples demanded	
#	fileRand		= sys.argv[3]			 # name of file that will contain the random examples
#	fileEx     	= sys.argv[4]       	 # file containing train intentionsal complete examples (.int)
#	fileBkg    	= sys.argv[5]       	 # file containing background knowledge
#	fileExcelLear  = sys.argv[6]       	 # prefix of files that will contain Lear results
#	fileExcelTilde = sys.argv[7]			 # prefix of files that will contain Tilde results
#	fileExcelNfoil = sys.argv[8]             # prefix of files that will contain Nfoil results
#	nbCross    	= sys.argv[9]       	 # cross validation identifier
#	nbFold     	= sys.argv[10]       	 # number of folds of the cross validation
#	factor     	= sys.argv[11]         	 # create factor ambiguous examples from each complete example   
#	nbErrors   	= sys.argv[12]       	 # number of accepted errors on negative examples
#	nbTries    	= sys.argv[13]       	 # number of tries to enhance an hypothesis
#                                     	 	 # having less than nbErrors
#	compWeight 	= sys.argv[14]	     	 # weight of the only compatible examples
#	doubleRep		= sys.argv[15]			 # double when double representation is used
#	probaMin   	= sys.argv[16]   	 	 # min level of ambiguity
#	probaMax   	= sys.argv[17]   	 	 # max level of ambiguity



# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# ================================ GLOBAL VARIABLES ============================

learDirectory = os.getenv('LEAR_DIR')
LEAR = os.path.join(learDirectory, "topLear3.pl")

# =================================== FONCTIONS ================================

def displayMessage(Message) :
	print()
	print("__________________________________________________________________")
	print("                             ", Message)
	print("__________________________________________________________________")
	print()

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     	= sys.argv[0]       	 # script name
	fileLanguage	= sys.argv[1]			 # file (int_bkg) containing the background and the concept
	nbEx			= sys.argv[2]			 # number of random examples demanded	
	fileRand		= sys.argv[3]			 # name of file that will contain the random examples
	fileEx     	= sys.argv[4]       	 # file containing train intentionsal complete examples (.int)
	fileBkg    	= sys.argv[5]       	 # file containing background knowledge
	fileExcelLear  = sys.argv[6]       	 # prefix of files that will contain Lear results
	fileExcelTilde = sys.argv[7]			 # prefix of files that will contain Tilde results
	fileExcelNfoil = sys.argv[8]             # prefix of files that will contain Nfoil results
	nbCross    	= sys.argv[9]       	 # cross validation identifier
	nbFold     	= sys.argv[10]       	 # number of folds of the cross validation
	factor     	= sys.argv[11]         	 # create factor ambiguous examples from each complete example   
	nbErrors   	= sys.argv[12]       	 # number of accepted errors on negative examples
	nbTries    	= sys.argv[13]       	 # number of tries to enhance an hypothesis
                                     	 	 # having less than nbErrors
	compWeight 	= sys.argv[14]	     	 # weight of the only compatible examples
	doubleRep		= sys.argv[15]			 # double when double representation is used
	probaMin   	= sys.argv[16]   	 	 # min level of ambiguity
	probaMax   	= sys.argv[17]   	 	 # max level of ambiguity

	print("begin of the script ", script)

									# create the random examples
	program = "create_int_examples_dist.pl"
	args = [program, fileLanguage, nbEx, fileRand]
	subprocess.call(args)
									# complete the random examples
	args = [LEAR, "-X", fileRand, "-B", fileBkg, "-o", fileEx]	     
	subprocess.call(args)

									# call magi_lear_tilde_nfoil_all_probas.py
	program = "magi_lear_tilde_nfoil_all_probas.py"
	args = [program, fileEx, fileBkg, fileExcelLear, fileExcelTilde, fileExcelNfoil,
		   nbCross, nbFold, factor, nbErrors, nbTries, compWeight, doubleRep, 
             probaMin, probaMax]
	subprocess.call(args)
							
	print("end of the script ", script)

# ====================================== END ===================================
