#!/usr/bin/python3.2
# (home + travail)

#!/usr/local/python32/bin/python3.2
# (magi)

# ==============================================================================
#							LES FICHIERS TESTS SONT RECOMPLETES					   
#	script     = sys.argv[0]       # script name
#	fileEx     = sys.argv[1]       # file containing train intentionsal complete examples (.int)
#	fileBkg    = sys.argv[2]       # file containing background knowledge
#	nbCross    = int(sys.argv[3])  # cross validation identifier
#	nbFold     = int(sys.argv[4])  # number of folds of the cross validation
#	ambiguity  = sys.argv[5]       # level of ambiguity (percentage)
 

# =================================== IMPORTS ==================================

import sys
import os
import multiprocessing as mp
import subprocess

# =============================== VARIABLES GLOBALES ===========================

learDirectory = os.getenv('LEAR_DIR')
LEAR = os.path.join(learDirectory, "topLear3.pl")

# =================================== FONCTIONS ================================
	
					# make a nbFold cross validation
def crossValidation(fileEx, fileBkg, cross, nbFold, ambiguity) :

	processName = mp.current_process().name
	pOut = open(processName + ".out", "w")
	pErr = open(processName + ".err", "w")

	suffixCross = "_n" + str(cross)

					# we are in the proba directory

	currentDirectory = os.getcwd() ;
	baseName = os.path.basename(currentDirectory)
	baseCrossDirectory = baseName + suffixCross

					# go to the cross validation directory
	crossDirectory = os.path.join(currentDirectory, baseCrossDirectory)
	os.chdir(crossDirectory)	

					# we are in the new cross validation directory
	     			               	         						     		               	
	for fold in range(1, nbFold+1) :
			
		print("fold : ", fold),
		foldBase = baseCrossDirectory + "_fold" + str(fold)
							
					# go to the current fold directory
		foldDirectory = os.path.join(crossDirectory, foldBase) 
		os.chdir(foldDirectory)
		
		fileDirectory = os.path.basename(foldDirectory)
		
					# (complete) train examples
		fileTrainComplete = fileDirectory + "_train" 
		fileTest          = fileDirectory + "_test"		
		fileTestNew		  = fileTest + "_new"

    				# complete les fichiers tests (qui etaient mal
					# completes precedemment) 		
		args = [LEAR, "-X", fileTest, "-B", fileBkg, "-o", fileTestNew]	     
		subprocess.call(args, stdout = pOut, stderr = pErr)
		 
    				# build extensional examples from the test file
		args = [LEAR, "-e", fileTestNew, "-B", fileBkg]	     
		subprocess.call(args, stdout = pOut, stderr = pErr)
    		

					# return to the cross directory	
		os.chdir("..")	

					# return to the proba directory
	os.chdir("..")		

	pOut.close()
	pErr.close()

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     = sys.argv[0]       # script name
	fileEx     = sys.argv[1]       # file containing train intentionsal complete examples (.int)
	fileBkg    = sys.argv[2]       # file containing background knowledge
	nbCross    = int(sys.argv[3])  # cross validation identifier
	nbFold     = int(sys.argv[4])  # number of folds of the cross validation
	ambiguity  = sys.argv[5]       # level of ambiguity (percentage)

	print("begin of the script ", script)

	suffixProba = "_p" + ambiguity
	directoryProba = fileEx    + suffixProba

							# go to the proba directory
	os.chdir(directoryProba)	
					
	processes = []

							# creation des process crossValidation
	for cross in range(0, nbCross) :	
		processes.append(
			             mp.Process(
						         target = crossValidation, 
						         name = "crossValidation_n" + str(cross), 
						         args = (
							             fileEx, fileBkg, cross, nbFold, ambiguity
							            )
                                     )
                          )   						

							# running the cross validations	  
	for p in processes : 
		p.start()      

							# waiting for the cross validations terminate
	for p in processes : 	
	 	p.join()       

	print("end of the script ", script)

# ====================================== END ===================================
