#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#                      CREATE N CONCURRENT K CROSS-VALIDATION WITH NFOIL
#                           FOR EACH LEVEL OF AMBIGUITY				   
#
#
#	script     = sys.argv[0]       	 # script name
#	fileEx     = sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
#	fileBkg    = sys.argv[2]       	 # file containing background knowledge
#	fileExcel  = sys.argv[3]       	 # prefix of files that will contain results in excel format
#	nbCross    = sys.argv[4]       	 # cross validation identifier
#	nbFold     = sys.argv[5]       	 # number of folds of the cross validation
#	probaMin   = int(sys.argv[6])    # min level of ambiguity
#	probaMax   = int(sys.argv[7])  

# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     = sys.argv[0]       	 # script name
	fileEx     = sys.argv[1]       	 # file containing train intentionsal complete examples (.int)
	fileBkg    = sys.argv[2]       	 # file containing background knowledge
	fileExcel  = sys.argv[3]       	 # prefix of files that will contain results in excel format
	nbCross    = sys.argv[4]       	 # cross validation identifier
	nbFold     = sys.argv[5]       	 # number of folds of the cross validation
	probaMin   = int(sys.argv[6])    	 # min level of ambiguity
	probaMax   = int(sys.argv[7])    	 # max level of ambiguity

	print("begin of the script ", script)

	for ambiguity in range(probaMin, probaMax+1, 10):

		print()
		print("============================================================")
		print("ambiguity = ", ambiguity)
		print()

		program = "magi_nfoil_one_proba.py"
		args = [program, fileEx, fileBkg, fileExcel, nbCross, nbFold, str(ambiguity)]
		subprocess.call(args)

	print("end of the script ", script)

# ====================================== END ===================================
