#!/usr/bin/python3.2
# (home + travail)

#!/usr/local/python32/bin/python3.2
# (magi)

# ==============================================================================
#                           CREATE N CONCURRENT K CROSS-VALIDATIONS	
#                           FOR EACH LEVEL OF AMBIGUITY
#                           Here : only learn from existing folds examples					   
#
#	script     = sys.argv[0]       	# nom du script
#	fileEx     = sys.argv[1]       	# file containing train intentionsal complete examples (.int)
#	fileBkg    = sys.argv[2]       	# file containing background knowledge
#	fileExcel  = sys.argv[3]       	# prefix of files that will contain results in excel format
#	nbCross    = int(sys.argv[4])  	# cross validation identifier
#	nbFold     = int(sys.argv[5])  	# number of folds of the cross validation
#    nbErrors   = sys.argv[6]        	# number of accepted errors on negative examples
#    nbTries    = sys.argv[7]      	# number of tries to enhance an hypothesis
                                   	# having less than nbErrors
#    compWeight = sys.argv[8]       	# weight of each only compatible example
                                   	# (exemple not covered but compatible)
#	probaMin   = int(sys.argv[9]) 	# min level of ambiguity
#	probaMax   = int(sys.argv[10]) 	# max level of ambiguity

# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     = sys.argv[0]       # script name
	fileEx     = sys.argv[1]       # file containing train intentionsal complete examples (.int)
	fileBkg    = sys.argv[2]       # file containing background knowledge
	fileExcel  = sys.argv[3]       # prefix of files that will contain results in excel format
	nbCross    = sys.argv[4]       # cross validation identifier
	nbFold     = sys.argv[5]       # number of folds of the cross validation
	nbErrors   = sys.argv[6]       # number of accepted errors on negative examples
	nbTries    = sys.argv[7]       # number of tries to enhance an hypothesis
                                    # having less than nbErrors
	compWeight = sys.argv[8]	      # weight of the only compatible examples
	probaMin   = int(sys.argv[9]) # min level of ambiguity
	probaMax   = int(sys.argv[10]) # max level of ambiguity

	print("begin of the script ", script)

	print("pmin = ", probaMin)
	print("pmax = ", probaMax)

	for ambiguity in range(probaMin, probaMax+1, 10):

		print("ambiguity = ", ambiguity)

						# call magi_onlyLear_nk_cross_validation_one_proba.py
		program = "magi_onlyLear_one_proba.py"
		args = [program, fileEx, fileBkg, fileExcel, nbCross, nbFold,
                str(ambiguity), nbErrors, nbTries, compWeight]
		subprocess.call(args)

	print("end of the script ", script)

# ====================================== END ===================================
