#!/usr/bin/python3.2
# (home + travail + magi)

# ==============================================================================
#                           CREATE TILDE ON N*K CONCURRENT CROSS VALIDATIONS	
#                           FOR EACH LEVEL OF AMBIGUITY				   
#
#	script     = sys.argv[0]       # script name
#	fileEx     = sys.argv[1]       # file containing train intentionsal complete examples (.int)
#	fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
#	nbCross    = sys.argv[3]       # cross validation identifier
#	nbFold     = sys.argv[4]       # number of folds of the cross validation
#	probaMin   = int(sys.argv[5])  # min level of ambiguity
#	probaMax   = int(sys.argv[6])  # max level of ambiguity

# =================================== IMPORTS ==================================

import sys
import os
import subprocess

# ===================================== MAIN ===================================

if __name__ == '__main__' :

	script     = sys.argv[0]       # script name
	fileEx     = sys.argv[1]       # file containing train intentionsal complete examples (.int)
	fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
	nbCross    = sys.argv[3]       # cross validation identifier
	nbFold     = sys.argv[4]       # number of folds of the cross validation
	probaMin   = int(sys.argv[5])  # min level of ambiguity
	probaMax   = int(sys.argv[6])  # max level of ambiguity

	print("begin of the script ", script)

	for ambiguity in range(probaMin, probaMax+1, 10):

		print()
		print("===========================================================")
		print("ambiguity = ", ambiguity)
		print()

						# call magi_tilde_one_proba.py
		program = "magi_tilde_one_proba.py"
		args = [program, fileEx, fileExcel, nbCross, nbFold, str(ambiguity)]
		subprocess.call(args)

	print("end of the script ", script)

# ====================================== END ===================================
