#!/usr/bin/python3.2

# (home + travail + magi)

# ==============================================================================
#         CLEAN FILES CREATED BY NFOIL_CROSS_VALIDATION_ONE_PROBA.PY	
#	
# script     = sys.argv[0]       # nom du script
# fileEx     = sys.argv[1]       # file containing intentionsal complete examples (.int)  
# fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
# nbCross    = int(sys.argv[3])  # number of cross validations 
# nbFold     = int(sys.argv[4])  # number of folds of the cross validation 
# probaMin   = sys.argv[5]       # level of ambiguity min (percentage)
# probaMax   = sys.argv[6]	   # level of ambiguity max (percentage)

# =================================== IMPORTS ==================================

import sys
import os

# =============================== VARIABLES GLOBALES ===========================

learDirectory 	= os.getenv('LEAR_DIR')
spaces		= ""

# =================================== FONCTIONS ================================
	
					# efface le fichier fileName
def removeFile(fileName):
		if os.path.exists(fileName) :
			print("efface : " + fileName)
			os.remove(fileName)
	
					# make a nbFold cross validation
def crossValidationClear(processName, fileEx, fileExcel, fileExcelProba,
       			     	 cross, nbFold, proba) :
 					
					# we are in the proba directory
	print("processName = ", processName)

	suffixCross = "_n" + str(cross)
	fileExcel = fileExcel + suffixCross

	currentDirectory = os.getcwd()

	baseName = os.path.basename(currentDirectory)
	baseCrossDirectory = baseName + suffixCross
	crossDirectory = os.path.join(currentDirectory, baseCrossDirectory)
	os.chdir(crossDirectory)	
	
					# we are in the cross directory
		
	removeFile(processName + ".out")
	removeFile(processName + ".err")
	removeFile(processName + ".csv")	

	for fold in range(1, nbFold+1) :
			
		print("fold : ", fold),
		foldBase = baseCrossDirectory + "_fold" + str(fold)
							
					# go to the directory of the current fold
		foldDirectory = os.path.join(crossDirectory, foldBase) 
		os.chdir(foldDirectory)
		
					# build the name of the nfoil files   
		file_ambiguity  = foldBase + "_train_ambiguous_close_world"	    
		fileNfoil 	 = file_ambiguity + "_nfoil.pl"
		
					# remove the Nfoil file built by "learToNfoilTrainTest.pl"
		removeFile(fileNfoil)
		
					# remove the output files of the run of nfoil								
		removeFile("nfoil.out")
		removeFile("nfoil.err")

					# remove the file containing parameters for nfoil
		removeFile("nfoil_cross_validation_one_proba.cmd")
		
					# return to the cross directory		
		os.chdir("..")	 
		
					# return to the proba directory
	os.chdir("..")		

# ===================================== MAIN ===================================

script     = sys.argv[0]       # nom du script
fileEx     = sys.argv[1]       # file containing intentionsal complete examples (.int)
fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
nbCross    = int(sys.argv[3])  # number of cross validations 
nbFold     = int(sys.argv[4])  # number of folds of the cross validation 
probaMin   = int(sys.argv[5])  # level of ambiguity min (percentage)
probaMax   = int(sys.argv[6])  # level of ambiguity max (percentage)

print("begin of the script ", script)

for proba in range(probaMin, probaMax+1, 10):

	print()
	print("======================================" )
	print()
	print("proba = " + str(proba))
	print()
	print()

	suffixProba 	= "_p" 		+ str(proba)
	fileExcelProba 	= fileExcel + suffixProba + ".csv"
	fileExcel1		= fileExcel + suffixProba
	directoryProba 	= fileEx    + suffixProba
	
	os.chdir(directoryProba)	
	removeFile(fileExcelProba)
	
	processProba = "nfoil_p" + str(proba)
			
								# lance les cross validations
	for cross in range(0, nbCross) :
		
		print()		
		print(spaces, "cross = " , cross)

		processName = processProba + "_n" + str(cross)
		crossValidationClear(processName, fileEx, fileExcel1, 
					      fileExcelProba, cross, nbFold, proba)		
		
	os.chdir("..")				# return in the initial directory
	
print("end of the script ", script)

# ====================================== END ===================================
