#!/usr/bin/python3.2

# (home + travail + magi)

# ==============================================================================
#         CLEAN FILES CREATED BY TILDE_CROSS_VALIDATION_ONE_PROBA.PY	
#	
# script     = sys.argv[0]       # nom du script
# fileEx     = sys.argv[1]       # file containing intentionsal complete examples (.int)
# fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
# nbCross    = int(sys.argv[3])  # number of cross validations 
# nbFold     = int(sys.argv[4])  # number of folds of the cross validation 
# probaMin   = sys.argv[5]       # level of ambiguity min (percentage)
# probaMax   = sys.argv[6]	   # level of ambiguity max (percentage)

# =================================== IMPORTS ==================================

import sys
import os
import shutil

# =================================== FONCTIONS ================================
	
					# efface le fichier fileName
def removeFile(fileName):
		if os.path.exists(fileName) :
			os.remove(fileName)
			print("efface : " + fileName)
	
def removeDir(dirName) :
	if os.path.exists(dirName) :
		shutil.rmtree(dirName)
		print("efface : " + dirName)
	
					# efface les fichiers tildes provenant 
					# d'une n-k cross validation
def crossValidationClear(processName, fileEx, fileExcel, cross, nbFold, proba) :
 					
					# we are in the proba directory

	suffixCross = "_n" + str(cross)
	fileExcel = fileExcel + suffixCross

	currentDirectory = os.getcwd()

	baseName = os.path.basename(currentDirectory)
	baseCrossDirectory = baseName + suffixCross
	crossDirectory = os.path.join(currentDirectory, baseCrossDirectory)
	os.chdir(crossDirectory)	
	
					# we are in the cross directory
		
	removeFile(fileExcel + ".csv")	
	removeFile(fileExcel + ".out")
	removeFile(fileExcel + ".err")

	for fold in range(1, nbFold+1) :
			
		print("fold : ", fold),
		foldBase = baseCrossDirectory + "_fold" + str(fold)
							
					# go to the directory of the current fold
		foldDirectory = os.path.join(crossDirectory, foldBase) 
		os.chdir(foldDirectory)
		
					# build the name of the Tilde files
		file1  = foldBase + "_train_ambiguous_close_world"     
		file2  = foldBase + "_train"	
	 
					# remove the Tilde files
		removeFile(file1 + "_tilde.kbj")
		removeFile(file2 + "_tilde.kbj")

		removeFile(file1 + "_tilde.ew")
		removeFile(file2 + "_tilde.ew")

		removeFile(file1 + "_tilde.bg.w")
		removeFile(file2 + "_tilde.bg.w")

		removeFile(file1 + "_tilde.kbi")
		removeFile(file2 + "_tilde.kbi")

		removeFile(file1 + "_tilde.kb")
		removeFile(file2 + "_tilde.kb")

		removeFile(file1 + "_tilde.kb.w")
		removeFile(file2 + "_tilde.kb.w")

		removeFile(file1 + "_tilde.s")
		removeFile(file2 + "_tilde.s")

		removeFile(file1 + "_tilde.bg")
		removeFile(file2 + "_tilde.bg")

					# remove the tilde directory containing the results
		removeDir("tilde")

					# remove the file containing parameters for Tilde
		removeFile("tilde_cross_validation_one_proba.cmd")
		
					# return to the cross directory
		os.chdir("..")	 
	
					# return to the proba directory
	os.chdir("..")	

# ===================================== MAIN ===================================

script     = sys.argv[0]       # nom du script
fileEx     = sys.argv[1]       # file containing intentionsal complete examples (.int)
fileExcel  = sys.argv[2]       # prefix of files that will contain results in excel format
nbCross    = int(sys.argv[3])  # number of cross validations 
nbFold     = int(sys.argv[4])  # number of folds of the cross validation 
probaMin   = int(sys.argv[5])  # level of ambiguity min (percentage)
probaMax   = int(sys.argv[6])  # level of ambiguity max (percentage)

print("begin of the script ", script)

for proba in range(probaMin, probaMax+1, 10):

	print()
	print("======================================")
	print()
	print("proba = " + str(proba))
	print()
	print()

	suffixProba 	= "_p" 		+ str(proba)
	fileExcelProba 	= fileExcel + suffixProba + ".csv"
	fileExcel1		= fileExcel + suffixProba
	directoryProba 	= fileEx    + suffixProba
	
	os.chdir(directoryProba)	
	removeFile(fileExcelProba)
			
								# parcourt les cross validations
	for cross in range(0, nbCross) :
		
		print()		
		print("cross = " , cross)

		processName = fileEx + "_cross" + str(cross)
		crossValidationClear(processName, fileEx, fileExcel1, 
						 cross, nbFold, proba)	
	
		removeFile("tildeCrossValidation_n" + str(cross) + ".err")
		removeFile("tildeCrossValidation_n" + str(cross) + ".out")		
		
	removeFile(fileExcel1 + ".csv")

	os.chdir("..")				# return in the initial directory

			
print("end of the script ", script)

# ====================================== END ===================================
