/* ======================================================================== */
/*                           TIME HANDLING                                  */
/* ======================================================================== */  


:- module(times,
           [
              get_current_time/3,
              display_duration/1,
              fdisplay_duration/2,
              hours_minutes_seconds/4
           ]
          ). 


get_current_time(H, M, S) :-
   get_time(T),
   stamp_date_time(T, date(_, _, _, H, M, S1, _, _, _), local),
   S is round(S1).


	/* return the ellpased times (in seconds) beetween two moments */
duration(H1, M1, S1, H2, M2, S2, D) :-
   D1 is H1*3600 + M1*60 + S1,
   D2 is H2*3600 + M2*60 + S2,
   D is D2 - D1.
   
   
hours_minutes_seconds(D, H, M, S) :-
   H is D // 3600,      
   RH is D rem 3600,
   M is RH // 60,     
   S is RH rem 60.
   
display_duration(D) :-
   hours_minutes_seconds(D, H, M, S),   
   display_hms(H, M, S).
   
 
display_hms(H, M, S) :-
   write(H),
   write(' h '),
   display_ms(M,S).
   
   
display_ms(M, S) :-
   write(M),
   write(' m '),
   display_s(S).

   
display_s(S) :-
   write(S),
   writeln(' s').
   
   
   
fdisplay_duration(Stream, D) :-
   hours_minutes_seconds(D, H, M, S),
   fdisplay_hms(Stream, H, M, S).
   
 
fdisplay_hms(Stream, H, M, S) :-
   write(Stream, H),
   write(Stream, ' h '),
   fdisplay_ms(Stream, M,S).
   
   
fdisplay_ms(Stream, M, S) :-
   write(Stream, M),
   write(Stream, ' m '),
   fdisplay_s(Stream, S).

   
fdisplay_s(Stream, S) :-
   write(Stream, S),
   fwriteln(Stream, ' s').   
